; tuergong.asm - Tuerklingel
; toene  ausgeben
; interner Oszi Tiny13 Teiler 8
; Beginn: 22.5.2013, Stand: 22.5.2013
; Author: Alfred Hell alhell@gmx.net
; 		funkt 
; Fuses:  FF 6A   ; mit CKDIV8
; PB2 = OUT  Verstaerker einschalten	-	
; PB1 = IN  Klingeltaster Eingang  int0

.NOLIST
.include "/usr/share/avra/tn13def.inc"
.LIST

.DEF  	temp1   = r17
.DEF  	temp2	= r18  
.DEF  	temp3	= r19
.DEF  	temp4	= r20
.DEF	temp5	= r21
.DEF	temp6	= r22
.DEF 	sare	= r24

.EQU  XTAL = 1600000
 
.ORG  0
  	rjmp	init

.ORG  	INT0addr
	rjmp	INT0handler
	reti
	reti
	reti
	reti
	reti
	reti
	reti

INT0handler:
	in	sare, SREG
	ldi	temp2, 1
	out	SREG, sare
	reti

init:
 	ldi	temp1, RAMEND     	; Stackpointer initialisieren
	out	SPL, temp1
	sbi	ACSR, ACD		; analog komperator ausschalten
	ldi	temp1, 0b00010000
	out	DDRB, temp1		; portb4 Ausgang Ton
	ldi	temp1, (1<<SE) | (1<<SM1)
	out	MCUCR, temp1		; power down enable

main:	ldi	temp1, 1<<INT0
	out	GIMSK, temp1		; int0 ein
	sei
	sleep
	cli
	clr	temp1
	out	GIMSK, temp1		; int ausschalten
	rcall	wait10ms
	sbic	PINB, 1			; prellen abwarten
	rjmp	main
	sbi	PORTB, 4		; Ton einschalten
	ldi	temp6, 3		; ca. 8 sek warten
schl4:	ser	temp5
schl3:	rcall	wait10ms
	dec	temp5
	brne	schl3
	dec	temp6
	brne	schl4
	cbi	PORTB, 4		; Ton abschalten
	rjmp	main

wait10ms:
	ldi	temp3, 22	; ca 10 ms warten
schl1:	ldi	temp4, 250
schl2:	dec	temp4
	brne	schl2
	dec	temp3
	brne	schl1
	ret

